#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>
#include <time.h>
float get_usesize( char *dirname );
float show_file_info( char *dirname, char *filename);

int main(int argc,char **argv) {

        float total_use=0;
        total_use=get_usesize(argv[1]);

	printf("%s size : %.1f\n",argv[1],total_use);

}

float get_usesize( char *dirname ) {

        float use_size=0;
        DIR *dir_ptr; /* the directory */
        struct dirent *direntp; /* each entry */

        if ( ( dir_ptr = opendir( dirname ) ) == NULL ) {
                fprintf(stderr,"ls1: cannot open %s\n", dirname);
        }
        else {
                while ( ( direntp = readdir( dir_ptr ) ) != NULL ) {


                        use_size+=show_file_info(dirname, direntp->d_name);




                }




        }

        closedir(dir_ptr);
        return use_size;
}

float show_file_info( char *dirname, char *filename) {



        float use_size=0;
        char path[strlen(dirname)+strlen(filename)+2];

        struct stat info;
        memset(path,0x0,sizeof(path));

        snprintf(path,(strlen(dirname)+strlen(filename))+2,"%s/%s",dirname,filename);

        if ( stat(path, &info) == -1 ) {
                perror( path ); /* say why */
        }
        else {
                if(strcmp(filename,".")==0 || strcmp(filename,"..")==0) {
                }
                else {

                        if(S_ISDIR(info.st_mode)) {

                                use_size+=get_usesize( path );
                        }
                        else {
                                use_size += (float)(info.st_size /(float)1000000);

                        }

                }
        }


        return (float)use_size;


}
